# Queue Permissions
# =================

resource "azurerm_servicebus_queue_authorization_rule" "app1Queue_Receiver" {
  name                = "App1_SasPolicy"
  namespace_name      = "${azurerm_servicebus_namespace.myServiceBusNamespace.name}"
  queue_name          = "${azurerm_servicebus_queue.app1Queue.name}"
  resource_group_name = "${azurerm_resource_group.myResourceGroup.name}"

  listen = true
  send   = false
  manage = false
}

resource "azurerm_servicebus_queue_authorization_rule" "app2Queue_Receiver" {
  name                = "App2_SasPolicy"
  namespace_name      = "${azurerm_servicebus_namespace.myServiceBusNamespace.name}"
  queue_name          = "${azurerm_servicebus_queue.app1Queue.name}"
  resource_group_name = "${azurerm_resource_group.myResourceGroup.name}"

  listen = true
  send   = false
  manage = false
}

resource "azurerm_servicebus_queue_authorization_rule" "app3Queue_Receiver" {
  name                = "App3_SasPolicy"
  namespace_name      = "${azurerm_servicebus_namespace.myServiceBusNamespace.name}"
  queue_name          = "${azurerm_servicebus_queue.app1Queue.name}"
  resource_group_name = "${azurerm_resource_group.myResourceGroup.name}"

  listen = true
  send   = false
  manage = false
}

# Topic Permissions
# =================

resource "azurerm_servicebus_topic_authorization_rule" "invoiceTopic-Sender1" {
  name                = "InvoiceTopic_Sender1_sasPolicy"
  namespace_name      = "${azurerm_servicebus_namespace.myServiceBusNamespace.name}"
  topic_name          = "${azurerm_servicebus_topic.invoiceTopic.name}"
  resource_group_name = "${azurerm_resource_group.myResourceGroup.name}"
  listen              = false
  send                = true
  manage              = false
}

resource "azurerm_servicebus_topic_authorization_rule" "invoiceTopic-Sender2" {
  name                = "InvoiceTopic_Sender2_sasPolicy"
  namespace_name      = "${azurerm_servicebus_namespace.myServiceBusNamespace.name}"
  topic_name          = "${azurerm_servicebus_topic.invoiceTopic.name}"
  resource_group_name = "${azurerm_resource_group.myResourceGroup.name}"
  listen              = false
  send                = true
  manage              = false
}
