
# Queues
# ======
resource "azurerm_servicebus_queue" "app1Queue" {
  name                = "App1"
  resource_group_name = "${azurerm_resource_group.myResourceGroup.name}"
  namespace_name      = "${azurerm_servicebus_namespace.myServiceBusNamespace.name}"
  enable_partitioning = true
}

resource "azurerm_servicebus_queue" "app2Queue" {
  name                = "App2"
  resource_group_name = "${azurerm_resource_group.myResourceGroup.name}"
  namespace_name      = "${azurerm_servicebus_namespace.myServiceBusNamespace.name}"
  enable_partitioning = true
}

resource "azurerm_servicebus_queue" "app3Queue" {
  name                = "App3"
  resource_group_name = "${azurerm_resource_group.myResourceGroup.name}"
  namespace_name      = "${azurerm_servicebus_namespace.myServiceBusNamespace.name}"
  enable_partitioning = true
}

# Topics
# ======

resource "azurerm_servicebus_topic" "invoiceTopic" {
  name                = "invoiceTopic"
  resource_group_name = "${azurerm_resource_group.myResourceGroup.name}"
  namespace_name      = "${azurerm_servicebus_namespace.myServiceBusNamespace.name}"
  enable_partitioning = true
}

# App 1 Subscription
# ==================

resource "azurerm_servicebus_subscription" "invoiceTopic_App1Subscription" {
  name                = "invoiceTopic_App1"
  resource_group_name = "${azurerm_resource_group.myResourceGroup.name}"
  namespace_name      = "${azurerm_servicebus_namespace.myServiceBusNamespace.name}"
  topic_name          = "${azurerm_servicebus_topic.invoiceTopic.name}"
  forward_to          = "${azurerm_servicebus_queue.app1Queue.name}"
  max_delivery_count  = 3
}

resource "azurerm_servicebus_subscription_rule" "invoiceTopic_App1Subscription_Rule" {
  name                = "App1Rule"
  resource_group_name = "${azurerm_resource_group.myResourceGroup.name}"
  namespace_name      = "${azurerm_servicebus_namespace.myServiceBusNamespace.name}"
  topic_name          = "${azurerm_servicebus_topic.invoiceTopic.name}"
  subscription_name   = "${azurerm_servicebus_subscription.invoiceTopic_App1Subscription.name}"
  filter_type         = "SqlFilter"
  sql_filter          = "app = 'appA'"
}

# App 2 Subscription
# ==================

resource "azurerm_servicebus_subscription" "invoiceTopic_App2Subscription" {
  name                = "invoiceTopic_App2"
  resource_group_name = "${azurerm_resource_group.myResourceGroup.name}"
  namespace_name      = "${azurerm_servicebus_namespace.myServiceBusNamespace.name}"
  topic_name          = "${azurerm_servicebus_topic.invoiceTopic.name}"
  forward_to          = "${azurerm_servicebus_queue.app2Queue.name}"
  max_delivery_count  = 3
}

resource "azurerm_servicebus_subscription_rule" "invoiceTopic_App2Subscription_Rule" {
  name                = "App2Rule"
  resource_group_name = "${azurerm_resource_group.myResourceGroup.name}"
  namespace_name      = "${azurerm_servicebus_namespace.myServiceBusNamespace.name}"
  topic_name          = "${azurerm_servicebus_topic.invoiceTopic.name}"
  subscription_name   = "${azurerm_servicebus_subscription.invoiceTopic_App2Subscription.name}"
  filter_type         = "SqlFilter"
  sql_filter          = "app = 'app2'"
}

# App 3 Subscription
# ==================

resource "azurerm_servicebus_subscription" "invoiceTopic_App3Subscription" {
  name                = "invoiceTopic_App3"
  resource_group_name = "${azurerm_resource_group.myResourceGroup.name}"
  namespace_name      = "${azurerm_servicebus_namespace.myServiceBusNamespace.name}"
  topic_name          = "${azurerm_servicebus_topic.invoiceTopic.name}"
  max_delivery_count  = 1
  forward_to          = "${azurerm_servicebus_queue.app3Queue.name}"
}

resource "azurerm_servicebus_subscription_rule" "invoiceTopic_App3Subscription_Rule" {
  name                = "App3Rule"
  resource_group_name = "${azurerm_resource_group.myResourceGroup.name}"
  namespace_name      = "${azurerm_servicebus_namespace.myServiceBusNamespace.name}"
  topic_name          = "${azurerm_servicebus_topic.invoiceTopic.name}"
  subscription_name   = "${azurerm_servicebus_subscription.invoiceTopic_App3Subscription.name}"
  filter_type         = "SqlFilter"
  sql_filter          = "app = 'app3'"
}

